function effects(timer)
	doeffect(timer,"win","unlock",1,2,20,{2,4})
	doeffect(timer,"best","unlock",6,30,2,{2,4})
	doeffect(timer,"tele","glow",1,5,20,{1,4})
	doeffect(timer,"hot","hot",1,80,10,{0,1})
	doeffect(timer,"bonus","bonus",1,2,20,{4,1})
	doeffect(timer,"wonder","wonder",1,10,5,{0,3})
	doeffect(timer,"sad","tear",1,2,20,{3,2})
	doeffect(timer,"sleep","sleep",1,5,30,{3,2})
end
	
function doeffect(timer,keyword,particle,count,chance,timing,colour)
	if (timer % timing == 0) then
		local this = findfeature(nil,"is",keyword)
		
		local c1 = colour[1]
		local c2 = colour[2]
		
		if (this ~= nil) then
			for k,v in ipairs(this) do
				if (v[1] ~= "empty") and (v[1] ~= "all") then
					local these = findall(v)
					
					if (#these > 0) then
						for a,b in ipairs(these) do
							local unit = mmf.newObject(b)
							local x,y = unit.values[XPOS],unit.values[YPOS]
							if unit.visible then
								for i=1,count do
									if (chance > 1) then
										if (math.random(chance) == 1) then
											MF_particle(particle,x,y,c1,c2)
										end
									else
										MF_particle(particle,x,y,c1,c2)
									end
								end
							end
						end
					end
				elseif (v[1] == "empty") then
					for i=1,roomsize-2 do
						for j=1,roomsize-2 do
							local tileid = i + j * roomsize
							
							if (unitmap[tileid] == nil) or ((unitmap[tileid] ~= nil) and (#unitmap[tileid] == 0)) then
								for f=1,count do
									if (chance > 1) then
										if (math.random(chance) == 1) then
											MF_particle(particle,i,j,c1,c2)
										end
									else
										MF_particle(particle,i,j,c1,c2)
									end
								end
							end
						end
					end
				end
			end
		end
	end
end

function particles(name,x,y,count,colour)
	MF_particles(name,x,y,count,colour[1],colour[2])
end