dirs = {{1,0},{0,1},{-1,0},{0,-1},{0,0}}
ndirs = {{1,0},{0,-1},{-1,0},{0,1},{0,0}}
materials = {"rock","lava","wall","ice","baba","keke","water","error","skull","grass","flag","empty","metal","heart","anni","door","key","box","all","hand","me","what","belt","yes","no","hedge","orb","level","cloud","star","spark","moon","rose","violet","group","brick","pillar","statue","dot","fungus","fruit","tree","fence","line"}
colours = {
	default = {0, 3},
	background = {0, 4},
	edges = {1, 0},
	backparticles = {6, 4},
	levels = {
		{1, 1},
		{6, 1},
		{1, 2},
		{5, 1},
		{4, 0},
		{2, 1},
	},
	intro = {
		presents = {1, 4},
		b = {4, 1},
		a = {4, 1},
		y = {4, 1},
		o = {4, 1},
		u = {4, 1},
		i = {0, 3},
		s = {0, 3},
		dash = {0, 3},
	},
}
conditions = {"on","near"}
simpleconds = {"alone","alone2"}

keys = 
{
	right = 0,
	up = 1,
	left = 2,
	down = 3,
	idle = 4,
	restart = 5,
	undo = 6,
	quit = 7,
	shift = 8,
}

tileslist =
{
	keke =
	{
		colour = {2, 2},
	},
	baba =
	{
		colour = {0, 3},
	},
	rock =
	{
		colour = {6, 2},
	},
	edge =
	{
		colour = {0, 2},
	},
	flag =
	{
		colour = {2, 4},
	},
	metal =
	{
		colour = {1, 0},
	},
	text_grass =
	{
		colour = {5, 1},
		active = {5, 3},
	},
	text_and =
	{
		colour = {0, 1},
		active = {0, 3},
	},
	text_hide =
	{
		colour = {3, 2},
		active = {3, 3},
	},
	text_follow =
	{
		colour = {5, 0},
		active = {5, 2},
	},
	text_float =
	{
		colour = {1, 2},
		active = {1, 4},
	},
	text_alone =
	{
		colour = {2, 1},
		active = {2, 2},
	},
	lava =
	{
		colour = {2, 3},
	},
	water =
	{
		colour = {1, 3},
	},
	wall =
	{
		colour = {1, 1},
	},
	text_empty =
	{
		colour = {0, 1},
		active = {0, 3},
	},
	text_metal =
	{
		colour = {1, 1},
		active = {0, 1},
	},
	text_weak =
	{
		colour = {1, 1},
		active = {1, 2},
	},
	text_near =
	{
		colour = {0, 1},
		active = {0, 3},
	},
	cloud =
	{
		colour = {1, 4},
	},
	pillar =
	{
		colour = {0, 1},
	},
	text_fungus =
	{
		colour = {6, 0},
		active = {6, 1},
	},
	text_baba =
	{
		colour = {4, 0},
		active = {4, 1},
	},
	text_keke =
	{
		colour = {2, 1},
		active = {2, 2},
	},
	text_flag =
	{
		colour = {6, 1},
		active = {2, 4},
	},
	flag =
	{
		colour = {2, 4},
	},
	ice =
	{
		colour = {1, 2},
	},
	text_shift =
	{
		colour = {1, 2},
		active = {1, 3},
	},
	anni =
	{
		colour = {6, 2},
	},
	text_all =
	{
		colour = {0, 1},
		active = {0, 3},
	},
	text_right =
	{
		colour = {1, 3},
		active = {1, 4},
	},
	text_cloud =
	{
		colour = {1, 3},
		active = {1, 4},
	},
	text_pillar =
	{
		colour = {0, 0},
		active = {0, 1},
	},
	fungus =
	{
		colour = {6, 1},
	},
	text_rock =
	{
		colour = {6, 0},
		active = {6, 1},
	},
	text_lava =
	{
		colour = {2, 2},
		active = {2, 3},
	},
	text_wall =
	{
		colour = {1, 1},
		active = {0, 1},
	},
	text_ice =
	{
		colour = {1, 2},
		active = {1, 3},
	},
	text_is =
	{
		colour = {0, 1},
		active = {0, 3},
	},
	text_anni =
	{
		colour = {6, 1},
		active = {6, 2},
	},
	text_more =
	{
		colour = {4, 0},
		active = {4, 1},
	},
	text_safe =
	{
		colour = {0, 1},
		active = {0, 3},
	},
	text_up =
	{
		colour = {1, 3},
		active = {1, 4},
	},
	star =
	{
		colour = {2, 4},
	},
	text_rose =
	{
		colour = {2, 1},
		active = {2, 2},
	},
	text_fruit =
	{
		colour = {2, 1},
		active = {2, 2},
	},
	text_water =
	{
		colour = {1, 2},
		active = {1, 3},
	},
	text_win =
	{
		colour = {6, 1},
		active = {2, 4},
	},
	text_push =
	{
		colour = {6, 0},
		active = {6, 1},
	},
	text_stop =
	{
		colour = {5, 0},
		active = {5, 1},
	},
	text_move =
	{
		colour = {5, 1},
		active = {5, 3},
	},
	text_best =
	{
		colour = {2, 3},
		active = {2, 4},
	},
	text_tele =
	{
		colour = {1, 2},
		active = {1, 4},
	},
	hand =
	{
		colour = {0, 3},
	},
	text_left =
	{
		colour = {1, 3},
		active = {1, 4},
	},
	text_star =
	{
		colour = {6, 1},
		active = {2, 4},
	},
	text_red =
	{
		colour = {2, 1},
		active = {2, 2},
	},
	fruit =
	{
		colour = {2, 2},
	},
	text_melt =
	{
		colour = {1, 2},
		active = {1, 3},
	},
	text_hot =
	{
		colour = {2, 2},
		active = {2, 3},
	},
	text_you =
	{
		colour = {4, 0},
		active = {4, 1},
	},
	text_not =
	{
		colour = {2, 1},
		active = {2, 2},
	},
	text_sink =
	{
		colour = {1, 2},
		active = {1, 3},
	},
	heart =
	{
		colour = {4, 2},
	},
	door =
	{
		colour = {2, 2},
	},
	text_hand =
	{
		colour = {0, 1},
		active = {0, 3},
	},
	text_down =
	{
		colour = {1, 3},
		active = {1, 4},
	},
	spark =
	{
		colour = {6, 2},
	},
	text_violet =
	{
		colour = {3, 2},
		active = {3, 3},
	},
	text_tree =
	{
		colour = {5, 1},
		active = {5, 2},
	},
	text_stick =
	{
		colour = {5, 1},
		active = {5, 3},
	},
	text_poof =
	{
		colour = {2, 0},
		active = {2, 1},
	},
	skull =
	{
		colour = {2, 1},
	},
	grass =
	{
		colour = {5, 0},
	},
	text_skull =
	{
		colour = {2, 0},
		active = {2, 1},
	},
	text_heart =
	{
		colour = {4, 1},
		active = {4, 2},
	},
	text_door =
	{
		colour = {2, 1},
		active = {2, 2},
	},
	text_text =
	{
		colour = {4, 0},
		active = {4, 1},
	},
	text_sleep =
	{
		colour = {1, 3},
		active = {1, 4},
	},
	text_spark =
	{
		colour = {6, 2},
		active = {2, 4},
	},
	text_blue =
	{
		colour = {3, 2},
		active = {3, 3},
	},
	tree =
	{
		colour = {5, 2},
	},
	key =
	{
		colour = {2, 4},
	},
	text_key =
	{
		colour = {6, 1},
		active = {2, 4},
	},
	text_open =
	{
		colour = {6, 1},
		active = {2, 4},
	},
	text_shut =
	{
		colour = {2, 1},
		active = {2, 2},
	},
	text_has =
	{
		colour = {0, 1},
		active = {0, 3},
	},
	box =
	{
		colour = {6, 2},
	},
	text_box =
	{
		colour = {6, 0},
		active = {6, 1},
	},
	belt =
	{
		colour = {1, 1},
	},
	text_make =
	{
		colour = {0, 1},
		active = {0, 3},
	},
	text_fall =
	{
		colour = {5, 1},
		active = {5, 3},
	},
	violet =
	{
		colour = {3, 3},
	},
	text_fence =
	{
		colour = {6, 0},
		active = {6, 1},
	},
	text_belt =
	{
		colour = {1, 2},
		active = {1, 3},
	},
	me =
	{
		colour = {3, 1},
	},
	text_me =
	{
		colour = {3, 0},
		active = {3, 1},
	},
	what =
	{
		colour = {0, 3},
	},
	text_what =
	{
		colour = {0, 1},
		active = {0, 3},
	},
	text_swap =
	{
		colour = {3, 0},
		active = {3, 1},
	},
	text_pull =
	{
		colour = {6, 1},
		active = {6, 2},
	},
	text_on =
	{
		colour = {0, 1},
		active = {0, 3},
	},
	text_no =
	{
		colour = {2, 1},
		active = {2, 2},
	},
	moon =
	{
		colour = {2, 4},
	},
	rose =
	{
		colour = {2, 2},
	},
	fence =
	{
		colour = {6, 1},
	},
	text_yes =
	{
		colour = {5, 2},
		active = {5, 3},
	},
	no =
	{
		colour = {2, 2},
	},
	yes =
	{
		colour = {5, 3},
	},
	hedge =
	{
		colour = {5, 1},
	},
	text_hedge =
	{
		colour = {5, 0},
		active = {5, 1},
	},
	text_level =
	{
		colour = {4, 0},
		active = {4, 1},
	},
	text_orb =
	{
		colour = {4, 0},
		active = {4, 1},
	},
	orb =
	{
		colour = {4, 1},
	},
	text_bonus =
	{
		colour = {4, 0},
		active = {4, 1},
	},
	text_moon =
	{
		colour = {6, 1},
		active = {2, 4},
	},
	text_group =
	{
		colour = {3, 2},
		active = {3, 3},
	},
	text_line =
	{
		colour = {0, 2},
		active = {0, 3},
	},
	brick =
	{
		colour = {6, 3},
	},
	text_brick =
	{
		colour = {6, 0},
		active = {6, 1},
	},
	text_wonder =
	{
		colour = {0, 1},
		active = {0, 3},
	},
	text_eat =
	{
		colour = {2, 1},
		active = {2, 2},
	},
	text_statue =
	{
		colour = {0, 0},
		active = {0, 1},
	},
	statue =
	{
		colour = {0, 1},
	},
	text_chill =
	{
		colour = {1, 2},
		active = {1, 4},
	},
	dot =
	{
		colour = {0, 3},
	},
	text_dot =
	{
		colour = {0, 1},
		active = {0, 3},
	},
	text_sad =
	{
		colour = {1, 1},
		active = {3, 2},
	},
	text_fear =
	{
		colour = {2, 1},
		active = {2, 2},
	},
	line =
	{
		colour = {0, 3},
	},
}

tiles =
{
	["0,0"] = "edge",
	["1,0"] = "edge",
	["2,0"] = "baba",
	["3,0"] = "keke",
	["4,0"] = "rock",
	["5,0"] = "text_grass",
	["6,0"] = "metal",
	["7,0"] = "text_and",
	["8,0"] = "text_hide",
	["9,0"] = "text_follow",
	["10,0"] = "text_float",
	["11,0"] = "text_alone",
	["0,1"] = "edge",
	["1,1"] = "edge",
	["2,1"] = "lava",
	["3,1"] = "water",
	["4,1"] = "wall",
	["5,1"] = "text_empty",
	["6,1"] = "text_metal",
	["7,1"] = "text_weak",
	["8,1"] = "text_near",
	["9,1"] = "cloud",
	["10,1"] = "pillar",
	["11,1"] = "text_fungus",
	["0,2"] = "text_baba",
	["1,2"] = "text_keke",
	["2,2"] = "text_flag",
	["3,2"] = "flag",
	["4,2"] = "ice",
	["5,2"] = "text_shift",
	["6,2"] = "anni",
	["7,2"] = "text_all",
	["8,2"] = "text_right",
	["9,2"] = "text_cloud",
	["10,2"] = "text_pillar",
	["11,2"] = "fungus",
	["0,3"] = "text_rock",
	["1,3"] = "text_lava",
	["2,3"] = "text_wall",
	["3,3"] = "text_ice",
	["4,3"] = "text_is",
	["5,3"] = "text_anni",
	["6,3"] = "text_more",
	["7,3"] = "text_safe",
	["8,3"] = "text_up",
	["9,3"] = "star",
	["10,3"] = "text_rose",
	["11,3"] = "text_fruit",
	["0,4"] = "text_water",
	["1,4"] = "text_win",
	["2,4"] = "text_push",
	["3,4"] = "text_stop",
	["4,4"] = "text_move",
	["5,4"] = "text_best",
	["6,4"] = "text_tele",
	["7,4"] = "hand",
	["8,4"] = "text_left",
	["9,4"] = "text_star",
	["10,4"] = "text_red",
	["11,4"] = "fruit",
	["0,5"] = "text_melt",
	["1,5"] = "text_hot",
	["2,5"] = "text_you",
	["3,5"] = "text_not",
	["4,5"] = "text_sink",
	["5,5"] = "heart",
	["6,5"] = "door",
	["7,5"] = "text_hand",
	["8,5"] = "text_down",
	["9,5"] = "spark",
	["10,5"] = "text_violet",
	["11,5"] = "text_tree",
	["0,6"] = "text_stick",
	["1,6"] = "text_poof",
	["2,6"] = "skull",
	["3,6"] = "grass",
	["4,6"] = "text_skull",
	["5,6"] = "text_heart",
	["6,6"] = "text_door",
	["7,6"] = "text_text",
	["8,6"] = "text_sleep",
	["9,6"] = "text_spark",
	["10,6"] = "text_blue",
	["11,6"] = "tree",
	["0,7"] = "key",
	["1,7"] = "text_key",
	["2,7"] = "text_open",
	["3,7"] = "text_shut",
	["4,7"] = "text_has",
	["5,7"] = "box",
	["6,7"] = "text_box",
	["7,7"] = "belt",
	["8,7"] = "text_make",
	["9,7"] = "text_fall",
	["10,7"] = "violet",
	["11,7"] = "text_fence",
	["0,8"] = "text_belt",
	["1,8"] = "me",
	["2,8"] = "text_me",
	["3,8"] = "what",
	["4,8"] = "text_what",
	["5,8"] = "text_swap",
	["6,8"] = "text_pull",
	["7,8"] = "text_on",
	["8,8"] = "text_no",
	["9,8"] = "moon",
	["10,8"] = "rose",
	["11,8"] = "fence",
	["0,9"] = "text_yes",
	["1,9"] = "no",
	["2,9"] = "yes",
	["3,9"] = "hedge",
	["4,9"] = "text_hedge",
	["5,9"] = "text_level",
	["6,9"] = "text_orb",
	["7,9"] = "orb",
	["8,9"] = "text_bonus",
	["9,9"] = "text_moon",
	["10,9"] = "text_group",
	["11,9"] = "text_line",
	["0,10"] = "brick",
	["1,10"] = "text_brick",
	["2,10"] = "text_wonder",
	["3,10"] = "text_eat",
	["4,10"] = "text_statue",
	["5,10"] = "statue",
	["6,10"] = "text_chill",
	["7,10"] = "dot",
	["8,10"] = "text_dot",
	["9,10"] = "text_sad",
	["10,10"] = "text_fear",
	["11,10"] = "line",
}